/*
 * Choeps Next Generation
 * 
 * Mark Spencer <markster@marko.net>
 *
 * Copyright(C) 1999, Adtran, Inc.
 * 
 * Distributed under the terms of the GNU General Public License (GPL) Version
 *
 * Utilities for handeling IP addresses.
 *
 */

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <malloc.h>
#include <stdlib.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include "cheops.h"
#include "io.h"
#include "logger.h"
#include "event.h"
#include "cheops-sh.h"
#include "ip_utils.h"

int get_host(char *hostname, u32 *ip) 
{
	struct hostent *hp;
	hp = gethostbyname(hostname);
	if (hp) 
		memcpy(ip, hp->h_addr, sizeof(u32));
	else
		return -1;
	return 0;
}

char *ip2str(u32 ip)
{
	return inet_ntoa(*(struct in_addr *)&ip);
}

int str2ip(char *s)
{
	struct in_addr ip;
	
	inet_aton(s,&ip);
	
	return( ip.s_addr);
}

int allones(u32 mask)
{
	/* Check to be sure that this only has only a string of ones,
	   return non-zero on success */
	while(mask & 0x80000000) {
		mask = mask << 1;
	}
	return !mask;
}

unsigned short inet_checksum (void *addr, int len)
{
	register int nleft = len;
	register u_short *w = addr;
	register int sum = 0;
	u_short answer = 0;
        
	while (nleft > 1)
	{
		sum += *w++;
		nleft -= 2;
	}
	/* mop up an odd byte, if necessary */
	if (nleft == 1)
	{
		*(u_char *) (&answer) = *(u_char *) w;
		sum += answer;
	}
                                     	                            
	sum = (sum >> 16) + (sum & 0xffff);   /* add hi 16 to low 16 */
	sum += (sum >> 16);		/* add carry */
	answer = ~sum;		/* truncate to 16 bits */
	return (answer);
}
                                     	                                            