/*
 * Choeps Next Generation
 * 
 * Mark Spencer <markster@marko.net>
 *
 * Copyright(C) 1999, Adtran, Inc.
 * 
 * Distributed under the terms of the GNU General Public License (GPL) Version
 *
 * Utilities for handeling IP addresses.
 *
 */

#ifndef _IP_UTILS_H
#define _IP_UTILS_H


extern int get_host(char *hostname, u32 *ip);
extern char *ip2str(u32 ip);
extern int str2ip(char *s);
extern int allones(u32 mask);
extern unsigned short inet_checksum (void *addr, int len);

/*
 * Macros for telling what class the ip address is
 * the ip address MUST be in network byte order
 */
#define IP_CLASSA(x)     ( (((unsigned char *)&x)[0] & 0x80) == 0x00 )
#define IP_CLASSB(x)     ( (((unsigned char *)&x)[0] & 0xc0) == 0x80 )
#define IP_CLASSC(x)     ( (((unsigned char *)&x)[0] & 0xe0) == 0xc0 )

/*
 * Mecro's for seeing if the ip address is a directed network broadcast
 * address, the ip address given MUST be in network byte order
 */
#define IP_CLASSA_BROADCAST(the_ip)  (				\
	(							\
		(((unsigned char *)&the_ip)[4] == 0xff) &&	\
		(((unsigned char *)&the_ip)[3] == 0xff) &&	\
		(((unsigned char *)&the_ip)[2] == 0xff)		\
	) || (							\
		(((unsigned char *)&the_ip)[4] == 0) &&		\
		(((unsigned char *)&the_ip)[3] == 0) &&		\
		(((unsigned char *)&the_ip)[2] == 0)		\
	)							\
)

#define IP_CLASSB_BROADCAST(the_ip)  (				\
	(							\
		(((unsigned char *)&the_ip)[4] == 0xff) &&	\
		(((unsigned char *)&the_ip)[3] == 0xff)		\
	) || (							\
		(((unsigned char *)&the_ip)[4] == 0) &&		\
		(((unsigned char *)&the_ip)[3] == 0)		\
	)							\
)

#define IP_CLASSC_BROADCAST(the_ip)  (				\
	(							\
		(((unsigned char *)&the_ip)[4] == 0xff)		\
	) || (							\
		(((unsigned char *)&the_ip)[4] == 0)		\
	)							\
)


#endif /* _IP_UTILS_H */

